local Class = require 'libs.hump.class'
local Entity = require 'entities.Entity'

local babas = Class{
  __includes = Entity 
}

function babas:init(world,x,y)
	self.x=x
	self.y=y
	
	self.vx=150
	self.vy=300
	self.g=-1000

	self.hp=100

	self.time=0

	self.it=1

	self.type= love.math.random(3)
	self.img=love.graphics.newImage("assets/babas.png")
	self.imgt={}

	self.imgt[1]={}

	self.imgt[1][1]=love.graphics.newQuad(0,0,39,29,self.img:getDimensions())
	self.imgt[1][2]=love.graphics.newQuad(44,0,42,29,self.img:getDimensions())
	self.imgt[1][3]=love.graphics.newQuad(91,0,44,29,self.img:getDimensions())

	self.imgt[2]={}

	self.imgt[2][1]=love.graphics.newQuad(0,33,39,29,self.img:getDimensions())
	self.imgt[2][2]=love.graphics.newQuad(44,33,42,29,self.img:getDimensions())
	self.imgt[2][3]=love.graphics.newQuad(91,33,44,29,self.img:getDimensions())

	self.imgt[3]={}

	self.imgt[3][1]=love.graphics.newQuad(0,69,39,29,self.img:getDimensions())
	self.imgt[3][2]=love.graphics.newQuad(44,69,42,29,self.img:getDimensions())
	self.imgt[3][3]=love.graphics.newQuad(91,69,44,29,self.img:getDimensions())
	self.postura=false

	self.isGrounded = false

	Entity.init(self, world, x, y, 44,29)
	self.world:add(self, self:getRect())
end

function babas:collisionFilter(other)
  local x, y, w, h = self.world:getRect(other)
  local babasBottom = self.y + self.h
  local otherBottom = y + h
    return 'slide'
end


function babas:draw()	
		love.graphics.draw(self.img, self.imgt[self.type][self.it], self.x , self.y)
		love.graphics.print("Hp:" ..self.hp,self.x,self.y-40)
		--love.graphics.print("vx:" ..self.vx .. tostring(self.postura),self.x,self.y-80)

end

function babas:update(dt)


		self.y=self.y+self.vy*dt
		self.vy=self.vy-self.g*dt

		if self.vx==150 then
			self.postura=true
		else
			self.postura=false
		end

		self.time=self.time+dt
		if self.time > 0.1 then
			if self.it <3 then
				self.it=self.it+1
			else
				self.it=1
			end
			self.time=0
		end

		self.x=self.x-self.vx*dt
		
		if self.x<=0 or self.x >= 6400-42 then
			self.vx=-self.vx
		end 


	self.x, self.y, collisions, len = self.world:move(self, self.x, self.y, self.collisionFilter)

	  for i, coll in ipairs(collisions) do
	    if coll.normal.y < 0 then
	      self.isGrounded = true
	    else
	      self.isGrounded= false
	    end
	  end	
end

return babas