local Gamestate = require 'libs.hump.gamestate'
local Class = require 'libs.hump.class'
local LevelBase = require 'gamestates.LevelBase'
local camera = require 'libs.camera'
local espadachin= require "entities/espadachin"
local babas= require "entities/babas"
local restart=false
local player=nil
local Babas={}
local babaobs={}
local enemigos=0
local background=love.graphics.newImage("assets/f1.png")
local gameLevel1 = Class{
  __includes = LevelBase
}

function gameLevel1:init()
  
end

function gameLevel1:enter()
  LevelBase.init(self, "assets/levels/lv1.lua")
  player = espadachin(self.world, 2 , 422)
  table.insert(Babas,babas(self.world, 4176 ,416.5))
  table.insert(Babas,babas(self.world, 1275 ,417.5))
  table.insert(Babas,babas(self.world, 199 ,448.5))
  table.insert(Babas,babas(self.world, 3432 ,449.5))
  table.insert(Babas,babas(self.world, 2793 ,512.5))
  table.insert(Babas,babas(self.world, 6312 ,544.5))
  table.insert(Babas,babas(self.world, 5701 ,577.5))

   table.insert(babaobs, {2108 ,268.5})
   table.insert(babaobs, {2422 ,269.5})
   table.insert(babaobs, {3956 ,425.5})
   table.insert(babaobs, {4308 ,426.5})
   table.insert(babaobs, {915 ,428.5})
   table.insert(babaobs, {1968 ,430.5})
   table.insert(babaobs, {3378 ,456.5})
   table.insert(babaobs, {3505 ,458.5})
   table.insert(babaobs, {379 ,462.5})
   table.insert(babaobs, {2738 ,523.5})
   table.insert(babaobs, {2867 ,524.5})
   table.insert(babaobs, {6226 ,553.5})
   table.insert(babaobs, {5809 ,586.5})
   table.insert(babaobs, {5623 ,589.5})

  LevelBase.Entities:add(player)
  
  for c,bab in ipairs(Babas) do
    LevelBase.Entities:add(bab)
    enemigos=enemigos+1
  end
end

function gameLevel1:update(dt)
  self.map:update(dt)
  LevelBase.Entities:update(dt)
  LevelBase.positionCamera(self, player, camera)

  if player.y> 800 or player.hp<1 then
    player.sword=false
    LevelBase.Entities:remove(player)
    restart=true
  end
  
  for k, bab in pairs (Babas) do
    if CheckCollision(player.x+player.s,player.y+28,35,2.5,bab.x,bab.y,42,29) and player.sword and player.postura==bab.postura  then
      bab.hp=bab.hp-100
      if bab.hp<1 then
        LevelBase.Entities:remove(bab)
        table.remove(Babas,k)
        enemigos=enemigos-1
      end
    end

    if CheckCollision(player.x+player.s,player.y,35,54,bab.x,bab.y,42,29)  and not player.inmunity and bab.hp> 1 then
      player.hp=player.hp-30
      player.inmunity=true
    end
  
    for c, postb in pairs(babaobs) do
      if CheckCollision(bab.x, bab.y,42,29,postb[1],postb[2], 24,17) then
        bab.vx=-bab.vx
      end

    end
  end 

end

function gameLevel1:draw()
  for i = 0, 800 / background:getWidth() do
        for j = 0, 640 / background:getHeight() do
            love.graphics.draw(background, i * background:getWidth(), j * background:getHeight())
        end
  end
  camera:set()
  self.map:draw(-camera.x, -camera.y) -- Remember that we inherited map from LevelBase
  LevelBase.Entities:draw() -- this executes the draw function for each individual Entity
  camera:unset()
  love.graphics.print("Enemigos en el mapa: "..enemigos,400,100)
  if restart then
    love.graphics.print("Ha muerto, presione Enter para reiniciar",250,300)
  end

  if enemigos==0 then
    love.graphics.print("Ha eliminado a todos los enemigos, presione Enter para continuar",120,300)
  end
end

-- All levels will have a pause menu
function gameLevel1:keypressed(key)
  LevelBase:keypressed(key)

  if key=="return" and restart then
      enemigos=0
      player=nil
      babaobs={}
      Babas={}
      restart=false
      LevelBase.Entities:clear()
      LevelBase.Entities:remove(player)
      gameLevel1:enter()
  end

  --[[if enemigos==0 and key=="return" then
    player=nil
    babaobs={}
    Babas={}
    LevelBase.Entities:clear()
    LevelBase.Entities:remove(player)
    Gamestate.switch(gameLevel2)
  end]]
end

function CheckCollision(x1,y1,w1,h1,x2,y2,w2,h2)
  return    x1 < x2+w2 and 
        x2 < x1+w1 and 
        y1 < y2+h2 and 
        y2 < y1+h1
end


return gameLevel1
